

	#  Count the unread articles in a group
proc count_group { g {s1 ""} } {
		global news newsread newsunread groups sgroups

		if { $s1 == "" } {
			set s [connectit]
			if { $s == "" } {
				return
			}
		} else {
			set s $s1
		}

		socksend $s "group $g"
		set res [readsock $s]
		set news($g,low) [lindex [split $res ] 2]
		set news($g,high) [lindex [split $res ] 3]


		# This is just to drop old newsread variables
		foreach a [array names newsread $g,*] {
			if { $newsread($a) < $news($g,low) } {
				unset newsread($a)
			}
		}

		socksend $s "listgroup $g"
		set res [readsock $s]
		set val [string range $res 0 2]
		if { $val == 411 } {
			tk_dialog .xxme "$news(tclnews) $news(version)" "Subscribed group $g\nis no longer valid" info 0 OK
			if { [info exists groups($g)] }  {
				unset groups($g)
			}
			if { [info exists sgroups($g)] }  {
				unset sgroups($g)
			}
			foreach v [array names news *$g*] {
				unset news($v)
			}
			if { $s1 == "" } { disconnect $s }
			return ""
		} else {
			if { [rescode $res 211 ] } {
				if { $s1 == "" } { 
					disconnect $s 
				}
				return
			}
		}


		set res [readsock $s]
		set need 0
		while { $res != "." } {
			if { ![info exists newsread($g,$res)] } {
				set newsunread($g,$res) $res
				incr need
			} else {
				if { [info exists newsunread($g,$res)] } {
					unset newsunread($g,$res)
				}
			}
			set res [readsock $s]
		}
	set news($g,count) $need
	if { $s1 == "" } { disconnect $s }
	return $need
}

