
proc window { win geo title type args } {
	global news

wm withdraw .
catch "destroy $win"

toplevel $win 
wm title $win "$title"
wm minsize $win 10 10


#  This frame is availible for calling functions to add additional widgets
frame $win.uf -relief flat
pack $win.uf -expand 0 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

#
#   Create a uttons
frame $win.bf  -relief flat
pack $win.bf -in $win -anchor nw -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

# Create the buttons

foreach bt $args {
	set b [string tolower $bt ]
button $win.$b -text $bt
pack $win.$b -in $win.bf -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
}




frame $win.f1 -borderwidth 2 -relief raised 
pack $win.f1 -in $win -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4 -borderwidth 2 -relief raised 
pack $win.f1.f4 -in $win.f1 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4.f3 -borderwidth 2 -relief raised -width 50
pack $win.f1.f4.f3 -in $win.f1.f4 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4.f3.f17 -width 50
pack $win.f1.f4.f3.f17 -in $win.f1.f4.f3 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

if { $type == "text" } {
	$type $win.main  -wrap none -height 1 -width 1 -bg white -relief sunken -xscrollcommand "$win.f1.f4.f3.sb20 set" -yscrollcommand "$win.f1.f4.f3.f17.sb13 set"
	pack $win.main -in $win.f1.f4.f3.f17 -expand 1 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side left
	scrollbar $win.f1.f4.f3.f17.sb13  -command "$win.main yview" 
} else {
	frame $win.lf   -relief sunken -borderwidth 2
	$type $win.x    -height 1 -bg white -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat 
	$type $win.seq  -height 1 -bg white -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat 
	$type $win.main -height 1 -bg white -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat -xscrollcommand "$win.f1.f4.f3.sb20 set" -yscrollcommand "$win.f1.f4.f3.f17.sb13 set"
	$win.main configure -selectmode extended
	bind $win.main <1> "lstrmall $win "
	bind $win.main <Control-Button-1> "setseq $win %y "

	pack $win.lf   -in $win.f1.f4.f3.f17 -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.x    -in $win.lf           -anchor w -expand 0 -fill y    -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.main -in $win.lf           -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.seq  -in $win.lf           -anchor w -expand 0 -fill y    -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	scrollbar $win.f1.f4.f3.f17.sb13  -command "scroll $win" 
}
set news($win,sel) ""




pack $win.f1.f4.f3.f17.sb13 -in $win.f1.f4.f3.f17 -anchor center -expand 0 -fill y -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right

frame $win.f1.f4.f3.f19 -width 15
pack $win.f1.f4.f3.f19 -in $win.f1.f4.f3 -anchor se -expand 0 -fill none -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right

scrollbar $win.f1.f4.f3.sb20 -command "$win.main xview" -orient horizontal
pack $win.f1.f4.f3.sb20 -in $win.f1.f4.f3 -anchor center -expand 0 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side bottom


frame $win.f1.f5
pack $win.f1.f5 -in $win.f1 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

label $win.f1.f5.l -text "Mask: "
pack $win.f1.f5.l -expand 0 -fill x -side left
entry $win.f1.f5.e -textvariable news($win,mask)
pack $win.f1.f5.e -expand 1 -fill x -side left

if { $type == "text" } {
	button $win.f1.f5.b -text Search -command "search_txt $win"
} else {
	button $win.f1.f5.b -text Search -command "search_grp $win"
}
pack $win.f1.f5.b -expand 0 -fill x -side left


frame $win.f1.f6 -borderwidth 2 -relief raised -width 50
pack $win.f1.f6 -in $win.f1 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f6.f13 -borderwidth 2 -relief sunken -width 50
pack $win.f1.f6.f13 -in $win.f1.f6 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

label $win.f1.f6.f13.l17 -text "$news(tclnews) $news(version)" -textvariable news($win,l1)
pack $win.f1.f6.f13.l17 -in $win.f1.f6.f13 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f6.f14 -borderwidth 2 -width 50
pack $win.f1.f6.f14 -in $win.f1.f6 -anchor center -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

message $win.f1.f6.f14.mg19 -borderwidth 0 -padx 5 -pady 2 -textvariable news($win,message)  -width 400
pack $win.f1.f6.f14.mg19 -in $win.f1.f6.f14 -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

scale $win.scale -from 1 -to 100 -variable news($win,scale)  -showvalue true \
	-orient horizontal -state disabled 

frame $win.f1.f6.f15  -borderwidth 2 -relief sunken -width 50
pack $win.f1.f6.f15 -in $win.f1.f6 -anchor center -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side right

label $win.f1.f6.f15.l21 -text "$news(tclnews) $news(version)" -textvariable news($win,l2)
pack $win.f1.f6.f15.l21 -in $win.f1.f6.f15 -anchor center -expand 1 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
set  news($win,mask) ""
set  news($win,l1) $title
set  news($win,l2) $title
set  news($win,stop) 0
set  news($win,scale) 0

if { [info exists news($geo,geo)] } {
	wm geometry $win $news($geo,geo)
	bind $win <Configure> "setgeo $win %W $geo"
}

	return $win
}

proc setgeo { w1 w2 geo } {
	global news

	if { $w1 == $w2 } {
		set news($geo,geo) [wm geometry $w1]
	}
}

proc setmsg { win } {
	global news

	pack forget  $win.scale
	pack $win.f1.f6.f14.mg19 -in $win.f1.f6.f14 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
}

proc setscale { win args } {
	global news

	set n [llength $args]

	set from 1
	set to 100
	if { $n > 0 } {	
 	switch [llength $args] {
		1 { set to [lindex $args 0];set from 1 }
		2 { set from [lindex $args 0]; set to [lindex $args 1] }
		}
	}

	$win.scale configure -from $from -to $to -label $news($win,message)
	pack forget  $win.f1.f6.f14.mg19 
	pack $win.scale -in $win.f1.f6.f14 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
}

